# Wichteln mit Knecht Robobert

## Schritt 1: Leute einladen, am Wichteln teilzunehmen

Zum Beispiel per Mail, in etwa so wie [**`src/invite_mail_2021.txt`**](src/invite_mail_2021.txt).
Hier können dann auch die Rahmenbedingungen (Wert des Geschenks, Zeiträume, ...) geklärt werden.

## Schritt 2: Daten der Teilnehmer sammeln

Die Teilnehmer melden sich (z.B. per Mail beim Knecht-Robobert) an, und geben dabei ihre
Daten mit an. Dazu zählt im speziellen die Adresse, an die das Wichtelpaket geschickt
werden soll und die dazu dem entsprechenden Wichtel mitgeteilt wird.

Am besten, man sammelt die Daten in einer JSON-Datei der folgenden Struktur:
```
{
    "wug@cl.uni-heidelberg.de": {
        "name": "Wug",
        "fullname": "Mrs. Wug",
        "street": "Am Syntaxbaum 12",
        "address_appendix": "c/o Tim Verbatim",
        "city": "00325 Heidelberg",
        "note": "Ich ernähre mich ausschließlich von Buchstabensuppe, sorry! 😬"
    },
    ...
}
```
Dabei sind die Felder `address_appendix` und `note` völlig optional und müssen
nur eingetragen werden, wenn die Person einen entsprechenden Hinweis explizit
angibt.

## Schritt 3: Mailtext validieren, automatisiert die Zuordnung auswürfeln lassen und die Mails verschicken

Der Mailtext in [**`src/assignment_mail.txt`**](src/assignment_mail.txt) sollte
vor der Ausführung noch einmal begutachtet und ggf. angepasst werden.

Die restliche Arbeit wird dann vom Skript abgenommen:
1) `python main.py <teilnehmer.json>`
2) Bei Bedarf und wenig Vertrauen in die Technik (und natürlich nur, wenn man
selbst nicht beim Wichteln teilnehmen will) die Mails in `mails/` kontrollieren.
3) Mails automatisiert senden lassen. Man beachte, dass man sich in der 
aktuellen Konfiguration dazu im Uni-Netz befinden muss.
4) **Personenbezogene Daten unbedingt löschen, sobald alles zur Zufriedenheit 
aller abgewickelt ist!**


## Schritt 4: Ans digitale Pool-Whiteboard erinnern

Zum Beispiel mit einer Mail wie dieser: [**`src/whiteboard_reminder_mail.txt`**](src/whiteboard_reminder_mail.txt)